SystemOrganization addCategory: #Plotter!
SystemOrganization addCategory: #'Plotter-morph'!

Morph subclass: #PlotterMorph
	instanceVariableNames: 'form plotter drawsForm drawsPlotting drawingMode bisect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

!PlotterMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/18/2012 17:26'!
controlledByBisect: aNumber
	plotter controlledByBisect: aNumber.
	self changed! !

!PlotterMorph methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 01:10'!
drawOn: aCanvas
	super drawOn: aCanvas.
	[
	drawingMode drawsForm
		ifTrue: 
			[ form ifNotNil: [aCanvas paintImage: form at: self position]].
	drawingMode drawsPlotter
		ifTrue: 
			[
				aCanvas 
				translateBy: self position 
				during: 
					[:canvas| 
					plotter drawOn: (drawingMode blendingPlot
							ifTrue: [(AlphaBlendingCanvas on: canvas) alpha: 0.3]
							ifFalse: [canvas]) ].
			]
		
	] on: Error 
			do: [:e| Transcript cr; print: e; flush ]! !

!PlotterMorph methodsFor: 'initialize' stamp: 'HwaJong 12/20/2012 14:58'!
initialize 
	super initialize.
	drawingMode := PMDMFormOnly new.
	self initializePlotter.! !

!PlotterMorph methodsFor: 'initialize' stamp: 'HwaJong 12/20/2012 15:25'!
initializePlotter
	"plotter := HistogramPlotter new."! !

!PlotterMorph methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 16:52'!
plotter: aPlotter 
	plotter := aPlotter! !

!PlotterMorph methodsFor: 'changing' stamp: 'HwaJong 12/20/2012 00:32'!
showFormOnly
	drawingMode := PMDMFormOnly new.
	self changed.! !

!PlotterMorph methodsFor: 'changing' stamp: 'HwaJong 12/20/2012 00:42'!
showPlotterOverForm
	drawingMode := PMDMPlotOverForm new.
	self changed.! !

!PlotterMorph methodsFor: 'changing' stamp: 'HwaJong 12/20/2012 00:33'!
showPlottingOnly
	drawingMode := PMDMPlotOnly new.
	self changed.! !

Object subclass: #GaussianBellCurve
	instanceVariableNames: 'mean standardDeviation gain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!GaussianBellCurve methodsFor: 'self evaluating' stamp: 'HwaJong 12/18/2012 23:05'!
denom
	^(2 * Float pi) sqrt * standardDeviation! !

!GaussianBellCurve methodsFor: 'drawing' stamp: 'HwaJong 12/20/2012 14:16'!
drawOn: aCanvas plotter: aPlotter
	| op |
	op := aPlotter pixelPointAtPixelX: (aPlotter xAxis pixelStart) onFunctionObject: self.
	^ aPlotter xAxis pixelStart to: aPlotter xAxis pixelEnd do: [ :px | 
		| p |
		p := aPlotter pixelPointAtPixelX: px onFunctionObject: self.
		aCanvas line: op to: p color: Color blue.
		op := p ]! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 23:46'!
gain
	^gain ifNil: [1] ifNotNil: [gain]! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 23:46'!
gain: aNumber
	gain := aNumber! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 22:47'!
mean
	^ mean! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 22:47'!
mean: aNumber
	mean := aNumber
! !

!GaussianBellCurve methodsFor: 'self evaluating' stamp: 'HwaJong 12/18/2012 23:05'!
normalizedX: aNumber
	^(aNumber - mean) / standardDeviation! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 22:47'!
standardDeviation
	^ standardDeviation! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 22:47'!
standardDeviation: aNumber
	standardDeviation := aNumber
! !

!GaussianBellCurve methodsFor: 'self evaluating' stamp: 'HwaJong 12/18/2012 23:46'!
value: aNumber
	^((self normalizedX: aNumber) squared / -2) exp / self denom * self gain! !

Object subclass: #HistoBar
	instanceVariableNames: 'startX endX tally'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!HistoBar classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/19/2012 00:57'!
startX: sx endX: ex tally: t
	^ self new
		startX: sx;
		endX: ex;
		tally: t! !

!HistoBar methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 14:30'!
drawOn: aCanvas plotter: aPlotter
	| px py px2 py2 p1 p2 |
	p1 := aPlotter pixelPointOfValuePoint: startX @ tally.
	p2 := aPlotter pixelPointOfValuePoint: endX @ 0.
	aCanvas fillRectangle: (p1 corner: p2) color: Color gray! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
endX
	^ endX! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
endX: aNumber
	endX := aNumber
! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
startX
	^ startX! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
startX: aNumber
	startX := aNumber
! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
tally
	^ tally! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
tally: aNumber
	tally := aNumber
! !

Object subclass: #HistogramPlotter
	instanceVariableNames: 'xAxis yAxis gaussian bars title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!HistogramPlotter methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/19/2012 00:03'!
controlledByBisect: aNumber
	gaussian mean: aNumber! !

!HistogramPlotter methodsFor: 'drawing' stamp: 'HwaJong 12/20/2012 00:42'!
drawOn: aCanvas
	xAxis drawOn: aCanvas.
	yAxis drawOn: aCanvas.
	bars do: [:bar| bar drawOn: aCanvas plotter: self].
	gaussian drawOn: aCanvas plotter: self.
	aCanvas drawString: title at: (self titlePosition) font: (self titleFont) color: (Color black).! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/19/2012 19:55'!
initialize 
	super initialize.
	self title: 'BATTERY LIFETIMES (YEARS)'.
	self initializeXAxis.
	self initializeYAxis.
	self initializeGaussian.
	self initializeBars.! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/19/2012 17:32'!
initializeBars
	bars := {
		HistoBar startX: 2.5 endX: 3.0 tally: 4. 
		HistoBar startX: 2.0 endX: 2.5 tally: 1.
		HistoBar startX: 1.5 endX: 2.0 tally: 2.
		HistoBar startX: 3.0 endX: 3.5 tally: 15.
		HistoBar startX: 3.5 endX: 4.0 tally: 10.
		HistoBar startX: 4.0 endX: 4.5 tally: 5.
		HistoBar startX: 4.5 endX: 5.0 tally: 3.}.
! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/19/2012 17:31'!
initializeGaussian
	gaussian := 
		GaussianBellCurve new 
			mean: 3.413818359375; 
			standardDeviation: 0.6999999105930328;
			gain: 26.1328125.
! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 13:23'!
initializeXAxis
	xAxis := 
		HorizontalPlotterAxis new
			fixedPixel: 460;
			pixelStart: 62;
			pixelEnd: 669;
			valueStart: 0.0 valueEnd: 6.0;
			ticks: (0.0 to: 6.0 by: 0.5).
! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 13:23'!
initializeYAxis
	yAxis := 
		VerticalPlotterAxis new
			fixedPixel: 62;
			pixelStart: 58;
			pixelEnd: 460;
			valueStart: 16.0 valueEnd: 0.0;
			ticks: (0 to: 16 by: 2);
			title: 'FREQUENCY'.
! !

!HistogramPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 14:15'!
pixelPointAtPixelX: px onFunctionObject: function
	| py vx |
	vx := self xAxis mapper unmap: px.
	py := self yAxis mapper map: (function value: vx).
	^ px @ py! !

!HistogramPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 13:06'!
pixelPointOfValuePoint: aPoint
	^(xAxis mapper map: aPoint x) @ (yAxis mapper map: aPoint y)! !

!HistogramPlotter methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 19:55'!
title
	^ title! !

!HistogramPlotter methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 19:55'!
title: aString
	title := aString
! !

!HistogramPlotter methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:58'!
titleFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 12 emphasized: 0! !

!HistogramPlotter methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 20:03'!
titlePosition
	^((xAxis pixelStart) + ((xAxis pixelEnd - xAxis pixelStart) - (self titleFont widthOfStringOrText: title))/2.0)@21! !

!HistogramPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 13:07'!
valuePointOfPixelPoint: aPoint
	^(xAxis mapper unmap: aPoint x) @ (yAxis mapper unmap: aPoint y)! !

!HistogramPlotter methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:29'!
xAxis
	^xAxis! !

!HistogramPlotter methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:29'!
yAxis
	^yAxis! !

Object subclass: #LinesPlotter
	instanceVariableNames: 'xAxis yAxis title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!LinesPlotter methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 17:15'!
controlledByBisect: aNumber
	xAxis pixelStart: aNumber! !

!LinesPlotter methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 01:19'!
drawOn: aCanvas
	xAxis drawOn: aCanvas.
	yAxis drawOn: aCanvas.
"	bars do: [:bar| bar drawOn: aCanvas plotter: self].
	gaussian drawOn: aCanvas plotter: self."
	title ifNotNil: 
		[aCanvas drawString: title at: (self titlePosition) font: (self titleFont) color: (Color black)].! !

!LinesPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 01:18'!
initialize 
	super initialize.
	self initializeXAxis.
	self initializeYAxis.
! !

!LinesPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 13:23'!
initializeXAxis
	xAxis := 
		HorizontalPlotterAxis new
			fixedPixel: 492;
			pixelStart: 74;
			pixelEnd: 682;
			mapper: 
				(MultiRangeMapper newWithAssociations: 
					{0.1->74.0.
					2->170.
					5->212.
					10->249.
					20->294.
					30->327.
					40->353.
					50->378.
					60->405.
					70->432.
					80->465.
					90->508.
					95->545.
					98->588.
					99->615.0.
					99.9->682.0});
			ticks: {0.1. 2. 5. 10. 20. 30. 40. 50. 60. 70. 80. 90. 95. 98. 99. 99.9}.
! !

!LinesPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 13:23'!
initializeYAxis
	yAxis := 
		VerticalPlotterAxis new
			fixedPixel: 73;
			pixelStart: 48;
			pixelEnd: 493;
			valueStart: 170.0 valueEnd: 50.0;
			ticks: (50 to: 170 by: 10).
! !

!LinesPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 15:25'!
pixelPointAtPixelX: px onFunctionObject: function
	| py vx |
	vx := self xAxis mapper unmap: px.
	py := self yAxis mapper map: (function value: vx).
	^ px @ py! !

!LinesPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 15:25'!
pixelPointOfValuePoint: aPoint
	^(xAxis mapper map: aPoint x) @ (yAxis mapper map: aPoint y)! !

!LinesPlotter methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 15:25'!
title
	^ title! !

!LinesPlotter methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 15:25'!
title: aString
	title := aString
! !

!LinesPlotter methodsFor: 'self evaluating' stamp: 'HwaJong 12/20/2012 15:25'!
titleFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 12 emphasized: 0! !

!LinesPlotter methodsFor: 'self evaluating' stamp: 'HwaJong 12/20/2012 15:25'!
titlePosition
	^((xAxis pixelStart) + ((xAxis pixelEnd - xAxis pixelStart) - (self titleFont widthOfStringOrText: title))/2.0)@21! !

!LinesPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 15:25'!
valuePointOfPixelPoint: aPoint
	^(xAxis mapper unmap: aPoint x) @ (yAxis mapper unmap: aPoint y)! !

!LinesPlotter methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 15:25'!
xAxis
	^xAxis! !

!LinesPlotter methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 15:25'!
yAxis
	^yAxis! !

Object subclass: #PMDrawingMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

PMDrawingMode subclass: #PMDMFormOnly
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

!PMDMFormOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:24'!
blendingPlot
	^false! !

!PMDMFormOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:24'!
drawsForm
	^true! !

!PMDMFormOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:24'!
drawsPlotter
	^false! !

PMDrawingMode subclass: #PMDMPlotOnly
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

!PMDMPlotOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:35'!
blendingPlot
	^false! !

!PMDMPlotOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:33'!
drawsForm
	^false! !

!PMDMPlotOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:34'!
drawsPlotter
	^true! !

PMDrawingMode subclass: #PMDMPlotOverForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

!PMDMPlotOverForm methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:36'!
blendingPlot
	^true! !

!PMDMPlotOverForm methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:35'!
drawsForm
	^true! !

!PMDMPlotOverForm methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:36'!
drawsPlotter
	^true! !

Object subclass: #PlotterAxis
	instanceVariableNames: 'ticks pixelStart pixelEnd mapper fixedPixel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

PlotterAxis subclass: #HorizontalPlotterAxis
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!HorizontalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 13:22'!
drawOn: aCanvas
	aCanvas line: self pixelStart @ self fixedPixel to: self pixelEnd @ self fixedPixel color: self color.
	self drawTicksOn: aCanvas! !

!HorizontalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 13:24'!
drawTicksOn: aCanvas
	| mp |
	mp := self mapper.
	self ticks do: [:each | 
		| pt lineFrom lineTo tickLabelPosition |
		pt := mp map: each.
		lineFrom := pt @ fixedPixel.
		lineTo := pt @ (fixedPixel+5).
		aCanvas line: lineFrom to: lineTo color: self color.
		tickLabelPosition := ((pt-((self tickFont widthOfStringOrText: each printString)/2)) @ (lineTo y)).
		aCanvas 
			drawString: each printString 
			at: tickLabelPosition
			font: self tickFont 
			color: self color
		].! !

!HorizontalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 18:59'!
tickFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 7 emphasized: 0! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 12:42'!
color
	^Color black! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 13:24'!
fixedPixel
	^ fixedPixel! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 13:24'!
fixedPixel: aNumber
	fixedPixel := aNumber
! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 12:40'!
mapper
	^mapper! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 12:37'!
mapper: anObject
	mapper := anObject! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
pixelEnd
	^pixelEnd! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
pixelEnd: aSmallInteger 
	pixelEnd := aSmallInteger ! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
pixelStart
	^pixelStart! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
pixelStart: aSmallInteger 
	pixelStart := aSmallInteger! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
ticks
	^ ticks! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
ticks: arrayOfNumbers
	ticks := arrayOfNumbers
! !

!PlotterAxis methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/21/2012 13:06'!
valueStart: aFloat valueEnd: aFloat2 
	mapper := RangeMapper from: (Range from: aFloat to: aFloat2) to: (Range from: pixelStart to: pixelEnd)! !

PlotterAxis subclass: #VerticalPlotterAxis
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!VerticalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 13:22'!
drawOn: aCanvas
	aCanvas line: self fixedPixel @ self pixelStart to: self fixedPixel @ self pixelEnd color: self color.
	self drawTicksOn: aCanvas.
	self drawTitleOn: aCanvas.! !

!VerticalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 13:24'!
drawTicksOn: aCanvas
	| mp |
	mp := self mapper.
	self ticks do: [:each | 
		| pt lineFrom lineTo tickLabelPosition |
		pt := mp map: each.
		lineFrom := fixedPixel @ pt.
		lineTo := (fixedPixel-5) @ pt.
		aCanvas line: lineFrom to: lineTo color: self color.
		tickLabelPosition := (((lineTo x)-(self tickFont widthOfStringOrText: each printString)) @ (pt-(self tickFont height/2))).
		aCanvas 
			drawString: each printString 
			at: tickLabelPosition
			font: self tickFont 
			color: self color
		].
! !

!VerticalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 01:20'!
drawTitleOn: aCanvas
	title ifNil: [^self].
	aCanvas 
		transformBy: (MatrixTransform2x3 withAngle: -90) 
		clippingTo: (0@0 extent: 500@500) 
		during: [:canvas | 
			canvas drawString: title at: (self titlePosition) font: (self titleFont) color: (self color)]
		smoothing: 2.! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 18:58'!
tickFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 7 emphasized: 0! !

!VerticalPlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 19:44'!
title
	^ title! !

!VerticalPlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 19:44'!
title: aString
	title := aString
! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:28'!
titleFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 9 emphasized: 0! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:46'!
titleOffset
	^((pixelEnd - pixelStart) - self titleWidth)/2.0! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:49'!
titlePosition
	^(pixelEnd - self titleOffset) negated @18! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:45'!
titleWidth
	^self titleFont widthOfStringOrText: title! !
